// coding: utf-8

function $(x) { return document.getElementById(x) }
function $tag(x) { return document.getElementsByTagName(x) }

window.addEventListener('load', function() {
    $('title').textContent = document.title;
    
    var width_1 = 80;
    var width_2 = 240;
    $('con').style.width = width_2 + 'px';
    $('button1').style.marginLeft = (width_2 + 1) + 'px';
    $('button1').style.width = width_1 + 'px';
    $('sql').style.height = '180px';
    $('sql').style.width = (width_1 + width_2) + 'px';
    $('sql').focus();   
    disp_cancel(1);
});

function add_res(str, clear) {
    var r = $('res');
    if (clear) {
        r.innerHTML = str;
    } else {
        r.innerHTML += str;
    }
    if (str.indexOf('<table>') == -1) {
        r.innerHTML += '<br />';
    }
}

function disp_cancel(x) {
    var b = $('button1');
    if (x > 0) {
        b.value = '送信';
        b.style.color = 'black';
        b.onclick = action;
    } else {
        b.value = '中止';
        b.style.color = 'red';
        b.onclick = cancel;
    }
}

function action(){
    var con = $('con').value;
    var sql = $('sql').value;
    var dat = 'con=' + con + '&sql=' + encodeURIComponent(sql);

    var res = $('res');
    res.cancelkey = '';
    res.url = 'ws://localhost:8180/test';
    var socket = new WebSocket(res.url);

    socket.onopen = function() {
        socket.send(dat);
        add_res('サーバから受信開始...', 1);
    }
    socket.onmessage = function(e) {
        if (e.data.indexOf('cancelkey=') == 0) {
            res.cancelkey = e.data
            disp_cancel(0);
            return
        }
        add_res(e.data);
    }
    socket.onerror = function() {
        add_res('エラー発生');
        disp_cancel(1);
        socket = undefined;
    }
    socket.onclose = function() {
        add_res('サーバからの受信終了');
        disp_cancel(1);
        socket = undefined;
    }
}

function cancel(){
    var res = $('res');
    if (res.cancelkey == '') {
        alert('no cancelkey');
        return
    }
    var socket = new WebSocket(res.url);
    socket.onopen = function() {
        socket.send(res.cancelkey);
        disp_cancel(1);
    }
    socket.onmessage = function(e) {
        add_res(e.data);
    }
    socket.onclose = function() {
        socket = undefined;
    }
}

window.addEventListener('beforeunload', function() {
    // Firefox では発動しないので未作成
});

window.addEventListener('unload', function() {
    // Firefox では発動しないので未作成
});
